## libmongocrypt 1.7.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)

# Preempt the MSVC_RUNTIME_LIBRARY properties
if (POLICY CMP0091)
   cmake_policy (SET CMP0091 NEW)
elseif (DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
   message (WARNING "The CMAKE_MSVC_RUNTIME_LIBRARY variable is set, but CMake is too old to understand it")
endif ()

project (mongocrypt C)

# Used for the csfle-markup util:
enable_language (CXX OPTIONAL)

set (CMAKE_C_STANDARD 99)

option (ENABLE_STATIC "Install static libraries" ON)
option (ENABLE_PIC
   "Enables building of position independent code for static library components."
   ON
)
option (ENABLE_BUILD_FOR_PPA "Maintainer-only option for preparing PPA build" OFF)
option (ENABLE_ONLINE_TESTS "Enable online tests and the csfle utility" ON)

if (ENABLE_WINDOWS_STATIC_RUNTIME)
   if (POLICY CMP0091)
      # CMake 3.15 makes this trivial:
      set (CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
   else ()
      # Fix it up the old-fashioned way
      string (REPLACE "/MDd" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
      string (REPLACE "/MD" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
      string (REPLACE "/MDd" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
      string (REPLACE "/MD" "" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
      string (APPEND CMAKE_C_FLAGS_DEBUG " /MTd")
      string (APPEND CMAKE_CXX_FLAGS_DEBUG " /MTd")
      string (APPEND CMAKE_C_FLAGS_RELEASE " /MT")
      string (APPEND CMAKE_CXX_FLAGS_RELEASE " /MT")
   endif ()
endif ()

list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include (GNUInstallDirs)

include (LTO)
include (ImportBSON)

option (MONGOCRYPT_ENABLE_DECIMAL128 "Enable extended support for Decimal128" ON)
mark_as_advanced (MONGOCRYPT_ENABLE_DECIMAL128)
set (maybe_dfp_library)
if (MONGOCRYPT_ENABLE_DECIMAL128)
   include (ImportDFP)
   set (maybe_dfp_library mongocrypt::intel_dfp)
endif ()

if (USE_SHARED_LIBBSON AND ENABLE_BUILD_FOR_PPA)
   message (FATAL_ERROR "PPA build requires static linking to libbson")
endif ()
if (DEFINED MONGOCRYPT_DFP_DIR AND ENABLE_BUILD_FOR_PPA)
   message (FATAL_ERROR "PPA build requires building with vendored Intel DFP")
endif ()

# Enable a higher warning level and warnings-as-errors
include (MongoC-Warnings)
option (ENABLE_MORE_WARNINGS_AS_ERRORS "Enable extra warnings-as-errors in the build." OFF)
if (ENABLE_MORE_WARNINGS_AS_ERRORS)
   mongoc_add_platform_compile_options (
      msvc:/W3 msvc:/WX msvc:/wd4996 msvc:/wd4359
      gnu-like:-Wall gnu-like:-Werror
      gnu-like:-Wswitch-enum gnu-like:-Wswitch-default
      )
   add_link_options (
      # Enable link-time warnings. VS 2015 sees LNK4099 spuriously, but it is a
      # non-fatal issue. LNK4217 and LNK4049 appear when using dllimport on
      # locally-defined symbols in kms-message.
      "$<IF:$<C_COMPILER_ID:MSVC>,/WX;/ignore:4217;/ignore:4049;/ignore:4099,-Werror>"
      )
endif ()

find_package (Threads REQUIRED)

add_subdirectory (bindings/cs)

include (GenerateExportHeader)

include (CTest)

set (MONGOCRYPT_PUBLIC_HEADERS
   src/mongocrypt-compat.h
   src/mongocrypt.h
)

set (MONGOCRYPT_SOURCES
   src/crypto/cng.c
   src/crypto/commoncrypto.c
   src/crypto/libcrypto.c
   src/crypto/none.c
   src/mc-array.c
   src/mc-efc.c
   src/mc-fle2-find-range-payload.c
   src/mc-fle2-insert-update-payload.c
   src/mc-fle2-encryption-placeholder.c
   src/mc-fle2-find-equality-payload.c
   src/mc-fle2-payload-iev.c
   src/mc-fle2-payload-uev.c
   src/mc-fle2-rfds.c
   src/mc-range-edge-generation.c
   src/mc-range-mincover.c
   src/mc-range-encoding.c
   src/mc-rangeopts.c
   src/mc-reader.c
   src/mc-tokens.c
   src/mongocrypt-binary.c
   src/mongocrypt-buffer.c
   src/mongocrypt-cache.c
   src/mongocrypt-cache-collinfo.c
   src/mongocrypt-cache-key.c
   src/mongocrypt-cache-oauth.c
   src/mongocrypt-ciphertext.c
   src/mongocrypt-crypto.c
   src/mongocrypt-ctx-datakey.c
   src/mongocrypt-ctx-decrypt.c
   src/mongocrypt-ctx-encrypt.c
   src/mongocrypt-ctx-rewrap-many-datakey.c
   src/mongocrypt-ctx.c
   src/mongocrypt-endpoint.c
   src/mongocrypt-kek.c
   src/mongocrypt-key.c
   src/mongocrypt-key-broker.c
   src/mongocrypt-kms-ctx.c
   src/mongocrypt-log.c
   src/mongocrypt-marking.c
   src/mongocrypt-opts.c
   src/mongocrypt-status.c
   src/mongocrypt-traverse-util.c
   src/mongocrypt-util.c
   src/mongocrypt.c
   src/os_win/os_mutex.c
   src/os_posix/os_mutex.c
   src/os_win/os_dll.c
   src/os_posix/os_dll.c
   )

# If MONGOCRYPT_CRYPTO is not set, choose a system default.
if (NOT MONGOCRYPT_CRYPTO)
   set (MONGOCRYPT_CRYPTO OpenSSL)
   if (APPLE)
      set (MONGOCRYPT_CRYPTO CommonCrypto)
   elseif (WIN32)
      set (MONGOCRYPT_CRYPTO CNG)
   endif ()
endif ()

# Otherwise, override with crypto hooks.
if (DISABLE_NATIVE_CRYPTO)
   set (MONGOCRYPT_CRYPTO none)
endif ()

set (MONGOCRYPT_ENABLE_CRYPTO 0)
set (MONGOCRYPT_ENABLE_CRYPTO_LIBCRYPTO 0)
set (MONGOCRYPT_ENABLE_CRYPTO_COMMON_CRYPTO 0)
set (MONGOCRYPT_ENABLE_CRYPTO_CNG 0)

if (MONGOCRYPT_CRYPTO STREQUAL CommonCrypto)
   message ("Building with common crypto")
   set (MONGOCRYPT_ENABLE_CRYPTO 1)
   set (MONGOCRYPT_ENABLE_CRYPTO_COMMON_CRYPTO 1)
elseif (MONGOCRYPT_CRYPTO STREQUAL CNG)
   message ("Building with CNG")
   set (MONGOCRYPT_ENABLE_CRYPTO 1)
   set (MONGOCRYPT_ENABLE_CRYPTO_CNG 1)
elseif (MONGOCRYPT_CRYPTO STREQUAL OpenSSL)
   message ("Building with OpenSSL")
   include (FindOpenSSL)
   message ("Found OpenSSL version ${OPENSSL_VERSION}")
   set (MONGOCRYPT_ENABLE_CRYPTO 1)
   set (MONGOCRYPT_ENABLE_CRYPTO_LIBCRYPTO 1)
elseif (MONGOCRYPT_CRYPTO STREQUAL none)
   message ("Building with no native crypto, hooks MUST be supplied with mongocrypt_setopt_crypto_hooks")
else ()
   message (FATAL_ERROR "Unknown crypto provider ${MONGOCRYPT_CRYPTO}")
endif ()

set (MONGOCRYPT_ENABLE_TRACE 0)
if (ENABLE_TRACE)
   message (WARNING "Building with trace logging. This is highly insecure. Do not use in a production environment")
   set (MONGOCRYPT_ENABLE_TRACE 1)
endif ()

set (BUILD_VERSION "0.0.0" CACHE STRING "Library version")
if (BUILD_VERSION STREQUAL "0.0.0")
   if (EXISTS ${CMAKE_BINARY_DIR}/VERSION_CURRENT)
      file (STRINGS ${CMAKE_BINARY_DIR}/VERSION_CURRENT BUILD_VERSION)
   elseif (EXISTS ${PROJECT_SOURCE_DIR}/VERSION_CURRENT)
      file (STRINGS ${PROJECT_SOURCE_DIR}/VERSION_CURRENT BUILD_VERSION)
      message (STATUS "File VERSION_CURRENT contained BUILD_VERSION ${BUILD_VERSION}")
   else ()
      find_package (PythonInterp)
      if (PYTHONINTERP_FOUND)
         execute_process (
            COMMAND ${PYTHON_EXECUTABLE} etc/calc_release_version.py
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            OUTPUT_VARIABLE CALC_RELEASE_VERSION
            RESULT_VARIABLE CALC_RELEASE_VERSION_RESULT
            OUTPUT_STRIP_TRAILING_WHITESPACE
         )
         if (NOT CALC_RELEASE_VERSION_RESULT STREQUAL 0)
            # If python failed above, stderr would tell the user about it
            message (FATAL_ERROR
               "BUILD_VERSION not specified and could not be calculated\
 (script invocation failed); specify in CMake command, -DBUILD_VERSION=<version>"
            )
         else ()
            set (BUILD_VERSION ${CALC_RELEASE_VERSION})
            message ("calculated BUILD_VERSION ${BUILD_VERSION}")
            file (WRITE ${CMAKE_BINARY_DIR}/VERSION_CURRENT ${CALC_RELEASE_VERSION})
         endif ()
      else ()
         message (FATAL_ERROR
            "BUILD_VERSION not specified and could not be calculated\
 (Python was not found on the system); specify in CMake command, -DBUILD_VERSION=<version>"
         )
      endif ()
      message (STATUS "Storing BUILD_VERSION ${BUILD_VERSION} in file VERSION_CURRENT for later use")
      file (WRITE ${PROJECT_SOURCE_DIR}/VERSION_CURRENT ${BUILD_VERSION})
   endif ()
else ()
   message (STATUS "Storing BUILD_VERSION ${BUILD_VERSION} in file VERSION_CURRENT for later use")
   file (WRITE ${PROJECT_SOURCE_DIR}/VERSION_CURRENT ${BUILD_VERSION})
endif ()

set (MONGOCRYPT_BUILD_VERSION ${BUILD_VERSION})

configure_file (
   "${PROJECT_SOURCE_DIR}/src/mongocrypt-config.h.in"
   "${PROJECT_BINARY_DIR}/src/mongocrypt-config.h"
)

# Define the mlib target, which is private and header-only. It is not exported
# nor are its headers installed.
add_library (_mongo-mlib INTERFACE)
add_library (mongo::mlib ALIAS _mongo-mlib)
list (APPEND MLIB_DEFINITIONS MLIB_USER)
CHECK_INCLUDE_FILE (strings.h HAVE_STRINGS_H)
if (HAVE_STRINGS_H)
   list (APPEND MLIB_DEFINITIONS MLIB_HAVE_STRINGS_H)
endif ()
set_property(
   TARGET _mongo-mlib
   APPEND PROPERTY INTERFACE_COMPILE_DEFINITIONS
   ${MLIB_DEFINITIONS}
   )
set_property(
   TARGET _mongo-mlib
   APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>"
   )

# kms-message
add_subdirectory (kms-message)

# Define mongocrypt library
add_library (mongocrypt SHARED ${MONGOCRYPT_SOURCES})
target_include_directories (
   mongocrypt
   PRIVATE
      "${CMAKE_CURRENT_SOURCE_DIR}/kms-message/src"
      "${CMAKE_CURRENT_SOURCE_DIR}/src"
   PUBLIC
      "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>"
   )
include (TestBigEndian)
TEST_BIG_ENDIAN (MONGOCRYPT_BIG_ENDIAN)
if (MONGOCRYPT_BIG_ENDIAN)
   message ("Detected byte order: big endian")
   list (APPEND MONGOCRYPT_DEFINITIONS MONGOCRYPT_BIG_ENDIAN)
else ()
   message ("Detected byte order: little endian")
   list (APPEND MONGOCRYPT_DEFINITIONS MONGOCRYPT_LITTLE_ENDIAN)
endif ()
target_compile_definitions (mongocrypt PRIVATE ${MONGOCRYPT_DEFINITIONS})
target_link_libraries (
   mongocrypt
   PRIVATE
      _mongocrypt::libbson_for_shared
      Threads::Threads
      kms_message_static
      $<BUILD_INTERFACE:mongo::mlib>
   PUBLIC
      ${maybe_dfp_library}
      ${CMAKE_DL_LIBS}
   )

if (NOT USE_SHARED_LIBBSON)
   if (APPLE)
      message ("compiling with unexported symbols list to hide bson symbols")
      set_target_properties (mongocrypt PROPERTIES LINK_FLAGS "-Wl,-unexported_symbols_list,\"${CMAKE_CURRENT_SOURCE_DIR}/cmake/libmongocrypt-hidden-symbols.txt\"")
   elseif (UNIX)
      message ("compiling with version map to version and hide bson symbols")
      set_target_properties (mongocrypt PROPERTIES LINK_FLAGS "-Wl,--version-script=\"${CMAKE_CURRENT_SOURCE_DIR}/cmake/libmongocrypt-hidden-symbols.map\"")
   endif ()
endif ()

if (NOT WIN32 AND CMAKE_VERSION VERSION_GREATER 3.25)
   # Do not enable conversion warnings with older cmake. Older cmake does not support
   # including headers as system headers when the headers are added to the project via
   # the add_subdirectory() CMake command. libbson produces conversion warnings and is
   # included in ImportBSON.cmake.
   target_compile_options (mongocrypt PRIVATE -Wconversion -Wsign-conversion)
   target_compile_options (kms_message_static PRIVATE -Wconversion -Wsign-conversion)
endif ()

generate_export_header (mongocrypt EXPORT_FILE_NAME src/mongocrypt-export.h BASE_NAME mongocrypt )

add_library (mongocrypt_static STATIC ${MONGOCRYPT_SOURCES})
# Checking CMAKE_C_FLAGS for -fPIC is not a foolproof way of checking whether
# -fPIC was set as a compiler flag. However, users were instructed before to
# pass -fPIC through CMAKE_C_FLAGS. This will prevent redundant output in
# the common case that users are setting -DCMAKE_C_FLAGS='-fPIC'
string (FIND "${CMAKE_C_FLAGS}" "-fPIC" FPIC_LOCATION)
if (NOT WIN32 AND ENABLE_PIC AND "${FPIC_LOCATION}" EQUAL "-1")
   target_compile_options (mongocrypt_static PUBLIC -fPIC)
   message ("Adding -fPIC to compilation of mongocrypt_static components")
endif ()
target_include_directories (
   mongocrypt_static
   PRIVATE
      "${CMAKE_CURRENT_SOURCE_DIR}/kms-message/src"
      "${CMAKE_CURRENT_SOURCE_DIR}/src"
   PUBLIC
      "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>"
   )
target_compile_definitions (
   mongocrypt_static
   PRIVATE
      ${MONGOCRYPT_DEFINITIONS}
   PUBLIC
      MONGOCRYPT_STATIC_DEFINE
      KMS_MSG_STATIC
   )
target_link_libraries (

=== debian/changelog ===
libmongocrypt (1.7.2-1) unstable; urgency=medium

  [ Kyle Kloberdanz ]
  * Drop remove-builtin.patch, integrated upstream
  * Disable Decimal128 on platforms without IntelDFP

  [ Roberto C. Sanchez ]
  * New upstream release.
  * Ensure that embedded code copies don't get included in .orig.tar.gz

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 13 Feb 2023 11:10:37 -0500

libmongocrypt (1.7.1-2) unstable; urgency=medium

  * Remove builtin which causes 32-bit ARM builds to fail

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Fri, 03 Feb 2023 16:24:00 -0600

libmongocrypt (1.7.1-1) unstable; urgency=medium

  [ Roberto C. Sanchez ]
  * Add libintelrdfpmath-dev to Build-Depends rather than using embedded
    sources.

  [ Kyle Kloberdanz ]
  * New upstream release.
  * Add myself to uploaders.
  * Update to Standards-Version 4.6.2 (no changes)

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Fri, 03 Feb 2023 13:25:46 -0600

libmongocrypt (1.6.2-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 06 Dec 2022 23:50:00 -0500

=== debian/control ===
Source: libmongocrypt
Priority: optional
Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
           Roberto C. Sanchez <roberto@connexer.com>,
           Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>
Build-Depends: debhelper (>= 10),
               cmake,
               libssl-dev,
               pkg-config,
               libintelrdfpmath-dev (>= 2.0u2-6) [!mips64el !mipsel],
               libbson-dev
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/mongodb/libmongocrypt

Package: libmongocrypt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbson-dev,
         libmongocrypt0 (= ${binary:Version}),
         libintelrdfpmath-dev (>= 2.0u2-6) [!mips64el !mipsel],
         ${misc:Depends}
Description: client-side field level encryption library - dev files
 libmongocrypt facilitates the client-side encryption and decryption,
 at the field level, of data stored in MongoDB.
 .
 This package contains the libmongocrypt and libkms_message development
 headers and libraries.

Package: libmongocrypt0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: client-side field level encryption library - runtime files
 libmongocrypt facilitates the client-side encryption and decryption,
 at the field level, of data stored in MongoDB.
 .
 This package contains the libmongocrypt and libkms_message runtime
 libraries.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CFLAGS_MAINT_APPEND  = -fPIC
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifneq (,$(filter $(DEB_HOST_ARCH),mipsel mips64el))
	DFP_CONFIG_OPTION=-DMONGOCRYPT_ENABLE_DECIMAL128=OFF
else
	DFP_CONFIG_OPTION=-DMONGOCRYPT_DFP_DIR=USE-SYSTEM
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -B$(CURDIR)/cmake-build -- \
	-DBUILD_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DUSE_SHARED_LIBBSON=ON \
	-DMONGOCRYPT_MONGOC_DIR=USE-SYSTEM \
	-DENABLE_ONLINE_TESTS=OFF \
	$(DFP_CONFIG_OPTION) \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_build:
	dh_auto_build -B$(CURDIR)/cmake-build -- all

override_dh_auto_install:
	dh_auto_install -B$(CURDIR)/cmake-build

override_dh_missing:
	dh_missing --fail-missing

## libmongocrypt 1.8.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,13 +78,13 @@
       )
 endif ()
 
-find_package (Threads REQUIRED)
-
 add_subdirectory (bindings/cs)
 
 include (GenerateExportHeader)
 
 include (CTest)
+include (Platform)
+
 
 set (MONGOCRYPT_PUBLIC_HEADERS
    src/mongocrypt-compat.h
@@ -99,11 +99,17 @@
    src/mc-array.c
    src/mc-efc.c
    src/mc-fle2-find-range-payload.c
+   src/mc-fle2-find-range-payload-v2.c
    src/mc-fle2-insert-update-payload.c
+   src/mc-fle2-insert-update-payload-v2.c
    src/mc-fle2-encryption-placeholder.c
    src/mc-fle2-find-equality-payload.c
+   src/mc-fle2-find-equality-payload-v2.c
    src/mc-fle2-payload-iev.c
+   src/mc-fle2-payload-iev-v2.c
    src/mc-fle2-payload-uev.c
+   src/mc-fle2-payload-uev-common.c
+   src/mc-fle2-payload-uev-v2.c
    src/mc-fle2-rfds.c
    src/mc-range-edge-generation.c
    src/mc-range-mincover.c
@@ -111,6 +117,7 @@
    src/mc-rangeopts.c
    src/mc-reader.c
    src/mc-tokens.c
+   src/mc-writer.c
    src/mongocrypt-binary.c
    src/mongocrypt-buffer.c
    src/mongocrypt-cache.c
@@ -270,26 +277,15 @@
    PUBLIC
       "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>"
    )
-include (TestBigEndian)
-TEST_BIG_ENDIAN (MONGOCRYPT_BIG_ENDIAN)
-if (MONGOCRYPT_BIG_ENDIAN)
-   message ("Detected byte order: big endian")
-   list (APPEND MONGOCRYPT_DEFINITIONS MONGOCRYPT_BIG_ENDIAN)
-else ()
-   message ("Detected byte order: little endian")
-   list (APPEND MONGOCRYPT_DEFINITIONS MONGOCRYPT_LITTLE_ENDIAN)
-endif ()
-target_compile_definitions (mongocrypt PRIVATE ${MONGOCRYPT_DEFINITIONS})
 target_link_libraries (
    mongocrypt
    PRIVATE
       _mongocrypt::libbson_for_shared
-      Threads::Threads
       kms_message_static
       $<BUILD_INTERFACE:mongo::mlib>
    PUBLIC
+      mongocrypt::platform
       ${maybe_dfp_library}
-      ${CMAKE_DL_LIBS}
    )
 
 if (NOT USE_SHARED_LIBBSON)
@@ -333,10 +329,17 @@
    )
 target_compile_definitions (
    mongocrypt_static
-   PRIVATE
-      ${MONGOCRYPT_DEFINITIONS}
    PUBLIC
       MONGOCRYPT_STATIC_DEFINE
       KMS_MSG_STATIC
    )
 target_link_libraries (
+   mongocrypt_static
+   PRIVATE
+      _mongocrypt::libbson_for_static
+      kms_message_static
+      $<BUILD_INTERFACE:mongo::mlib>
+   PUBLIC
+      mongocrypt::platform
+      ${maybe_dfp_library}
+   )

=== kms-message/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5)
project (kms_message
   VERSION 0.0.1
   LANGUAGES C
)

set (CMAKE_C_STANDARD 90)

include (CheckCCompilerFlag)
# All targets obey visibility, not just library targets.
cmake_policy (SET CMP0063 NEW)
set (CMAKE_C_VISIBILITY_PRESET hidden)
set (KMS_MESSAGE_SOURCES
   src/kms_b64.c
   src/kms_message/kms_b64.h
   src/hexlify.c
   src/hexlify.h
   src/kms_azure_request.c
   src/kms_crypto.h
   src/kms_crypto_none.c
   src/kms_crypto_windows.c
   src/kms_crypto_apple.c
   src/kms_crypto_libcrypto.c
   src/kms_caller_identity_request.c
   src/kms_decrypt_request.c
   src/kms_encrypt_request.c
   src/kms_gcp_request.c
   src/kms_kmip_reader_writer.c
   src/kms_kmip_request.c
   src/kms_kmip_response.c
   src/kms_kmip_response_parser.c
   src/kms_kv_list.c
   src/kms_kv_list.h
   src/kms_message.c
   src/kms_port.c
   src/kms_message/kms_azure_request.h
   src/kms_message/kms_caller_identity_request.h
   src/kms_message/kms_decrypt_request.h
   src/kms_message/kms_encrypt_request.h
   src/kms_message/kms_gcp_request.h
   src/kms_message/kms_message.h
   src/kms_message/kms_request.h
   src/kms_message/kms_request_opt.h
   src/kms_message/kms_response.h
   src/kms_message/kms_response_parser.h
   src/kms_request.c
   src/kms_request_opt.c
   src/kms_request_opt_private.h
   src/kms_request_str.c
   src/kms_request_str.h
   src/kms_response.c
   src/kms_response_parser.c
   src/sort.c
   )

if (DISABLE_NATIVE_CRYPTO)
   # Nothing
elseif (WIN32)
   set (KMS_MESSAGE_DEFINITIONS
         ${KMS_MESSAGE_DEFINITIONS}
         "KMS_MESSAGE_ENABLE_CRYPTO"
         "KMS_MESSAGE_ENABLE_CRYPTO_CNG")
elseif (APPLE)
   set (KMS_MESSAGE_DEFINITIONS ${KMS_MESSAGE_DEFINITIONS}
         "KMS_MESSAGE_ENABLE_CRYPTO"
         "KMS_MESSAGE_ENABLE_CRYPTO_COMMON_CRYPTO")
else()
   set (KMS_MESSAGE_DEFINITIONS
         ${KMS_MESSAGE_DEFINITIONS}
         "KMS_MESSAGE_ENABLE_CRYPTO"
         "KMS_MESSAGE_ENABLE_CRYPTO_LIBCRYPTO")
endif()

include (TestBigEndian)
TEST_BIG_ENDIAN (KMS_BIG_ENDIAN)
if (KMS_BIG_ENDIAN)
   message ("Detected byte order: big endian")
   set (KMS_MESSAGE_DEFINITIONS ${KMS_MESSAGE_DEFINITIONS} "KMS_MESSAGE_BIG_ENDIAN")
else ()
   message ("Detected byte order: little endian")
   set (KMS_MESSAGE_DEFINITIONS ${KMS_MESSAGE_DEFINITIONS} "KMS_MESSAGE_LITTLE_ENDIAN")
endif ()

add_library (
   kms_message SHARED
   ${KMS_MESSAGE_SOURCES}
)

add_library (
   kms_message_static STATIC
   ${KMS_MESSAGE_SOURCES}
)

string(FIND "${CMAKE_C_FLAGS}" "-fPIC" FPIC_LOCATION)
if (NOT WIN32 AND ENABLE_PIC AND "${FPIC_LOCATION}" EQUAL "-1")
   target_compile_options (kms_message_static PUBLIC -fPIC)
   message ("Adding -fPIC to compilation of kms_message_static components")
endif ()

add_library (
   kms_message_obj OBJECT
   ${KMS_MESSAGE_SOURCES}
)

target_compile_definitions (kms_message_obj PRIVATE ${KMS_MESSAGE_DEFINITIONS})

if (NOT DISABLE_NATIVE_CRYPTO)
   if (WIN32)
      target_link_libraries(kms_message "bcrypt" "crypt32")
      target_link_libraries(kms_message_static "bcrypt" "crypt32")
   elseif (APPLE)
      target_link_libraries (kms_message "-framework Security -framework CoreFoundation")
      target_link_libraries (kms_message_static "-framework Security -framework CoreFoundation")
   else()
      include (FindOpenSSL)
      target_link_libraries(kms_message "${OPENSSL_LIBRARIES}")
      target_include_directories(kms_message PRIVATE "${OPENSSL_INCLUDE_DIR}")
      target_link_libraries(kms_message_static "${OPENSSL_LIBRARIES}")
      target_include_directories(kms_message_static PRIVATE "${OPENSSL_INCLUDE_DIR}")
   endif()
endif ()

if ( CMAKE_COMPILER_IS_GNUCC )
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wall -Wno-unused-function -Wsign-compare")
endif()
if ( MSVC )
    # W4273 - inconsistent dll linkage
    # W4996 - POSIX name for this item is deprecated
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} /W3 /wd4273 /wd4996 /D_CRT_SECURE_NO_WARNINGS")
endif()

set_target_properties (kms_message PROPERTIES
   SOVERSION 0
   VERSION "0.0.0"
   OUTPUT_NAME "kms_message"
)

set_target_properties (kms_message_static PROPERTIES
   SOVERSION 0
   VERSION "0.0.0"
   OUTPUT_NAME "kms_message-static"
)

target_compile_definitions (kms_message PRIVATE KMS_MSG_COMPILATION)
target_compile_definitions (kms_message PRIVATE ${KMS_MESSAGE_DEFINITIONS})
set_property (TARGET kms_message APPEND PROPERTY
   COMPATIBLE_INTERFACE_STRING kms_message_MAJOR_VERSION
)

target_compile_definitions (kms_message_static PRIVATE KMS_MSG_COMPILATION)
target_compile_definitions (kms_message_static PRIVATE ${KMS_MESSAGE_DEFINITIONS})
target_compile_definitions (kms_message_static PUBLIC KMS_MSG_STATIC)
set_property (TARGET kms_message_static APPEND PROPERTY
   COMPATIBLE_INTERFACE_STRING kms_message_MAJOR_VERSION
   )

include (CMakePackageConfigHelpers)
if (ENABLE_STATIC)
   set (TARGETS_TO_INSTALL kms_message kms_message_static)
else ()
   set (TARGETS_TO_INSTALL kms_message)
endif ()
install (
   TARGETS ${TARGETS_TO_INSTALL}
   EXPORT kms_message_targets
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
   INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install (
   FILES
   src/kms_message/kms_azure_request.h
   src/kms_message/kms_b64.h
   src/kms_message/kms_caller_identity_request.h
   src/kms_message/kms_decrypt_request.h
   src/kms_message/kms_encrypt_request.h
   src/kms_message/kms_gcp_request.h
   src/kms_message/kms_message.h
   src/kms_message/kms_message_defines.h
   src/kms_message/kms_kmip_request.h
   src/kms_message/kms_kmip_response.h
   src/kms_message/kms_kmip_response_parser.h
   src/kms_message/kms_request.h
   src/kms_message/kms_request_opt.h
   src/kms_message/kms_response.h
   src/kms_message/kms_response_parser.h
   DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/kms_message
   COMPONENT Devel
)

include (CMakePackageConfigHelpers)
write_basic_package_version_file (
   "${CMAKE_CURRENT_BINARY_DIR}/kms_message/kms_message-config-version.cmake"
   VERSION 0.0.1
   COMPATIBILITY AnyNewerVersion
)

export (EXPORT kms_message_targets
   NAMESPACE mongo::
   FILE "${CMAKE_CURRENT_BINARY_DIR}/kms_message/kms_message_targets.cmake"
)

configure_file (cmake/kms_message-config.cmake
   "${CMAKE_CURRENT_BINARY_DIR}/kms_message/kms_message-config.cmake"
   COPYONLY
)

set (ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/kms_message)
install (EXPORT kms_message_targets
   NAMESPACE mongo::
   FILE kms_message_targets.cmake
   DESTINATION ${ConfigPackageLocation}
)

install (
   FILES
   cmake/kms_message-config.cmake
   "${CMAKE_CURRENT_BINARY_DIR}/kms_message/kms_message-config-version.cmake"
   DESTINATION ${ConfigPackageLocation}
   COMPONENT Devel
)

# pkg-config.
set (PKG_CONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
set (PKG_CONFIG_INCLUDEDIR "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set (PKG_CONFIG_LIBS "-L\${libdir} -lkms_message")
set (PKG_CONFIG_CFLAGS "-I\${includedir}")
configure_file (
   "${CMAKE_CURRENT_SOURCE_DIR}/cmake/libkms_message.pc.in"
   "${CMAKE_CURRENT_BINARY_DIR}/libkms_message.pc"
)

install (
   FILES "${CMAKE_CURRENT_BINARY_DIR}/libkms_message.pc"
   DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

# cannot run tests without crypto
if (NOT DISABLE_NATIVE_CRYPTO)
   add_executable (
      test_kms_request
      ${KMS_MESSAGE_SOURCES}
      test/test_kms_request.c
      test/test_kmip_reader_writer.c
      test/test_kms_util.c
      test/test_kms_kmip_request.c
      test/test_kms_kmip_response_parser.c
      test/test_kms_kmip_response.c
   )
   target_include_directories(test_kms_request PRIVATE ${PROJECT_SOURCE_DIR}/src)
   target_compile_definitions(test_kms_request PRIVATE ${KMS_MESSAGE_DEFINITIONS})

   if (WIN32)
      target_link_libraries(test_kms_request "bcrypt" "crypt32")
   elseif (APPLE)
      target_link_libraries (test_kms_request "-framework Security -framework CoreFoundation")
   else()
      include (FindOpenSSL)
      target_link_libraries(test_kms_request "${OPENSSL_LIBRARIES}")
      target_include_directories(test_kms_request PRIVATE "${OPENSSL_INCLUDE_DIR}")
   endif()

   add_test (
      NAME test_kms_request
      COMMAND test_kms_request
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
   )
endif ()

# build online_tests if OpenSSL is available (to create TLS connections).
if(DISABLE_NATIVE_CRYPTO)
   message ("test_kms_azure_online target disabled: Not building with native crypto.")
elseif(ENABLE_ONLINE_TESTS)
   add_executable(test_kms_azure_online test/test_kms_azure_online.c test/test_kms_util.c test/test_kms_online_util.c)
   target_include_directories(test_kms_azure_online PRIVATE ${PROJECT_SOURCE_DIR}/src)
   target_compile_definitions(test_kms_azure_online PRIVATE ${KMS_MESSAGE_DEFINITIONS})
   target_link_libraries(test_kms_azure_online _mongocrypt::mongoc)
   target_link_libraries(test_kms_azure_online kms_message_static)
   add_test (
      NAME test_kms_azure_online
      COMMAND test_kms_azure_online
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
   )

   add_executable(test_kms_gcp_online test/test_kms_gcp_online.c test/test_kms_util.c test/test_kms_online_util.c)
   target_include_directories(test_kms_gcp_online PRIVATE ${PROJECT_SOURCE_DIR}/src)
   target_compile_definitions(test_kms_gcp_online PRIVATE ${KMS_MESSAGE_DEFINITIONS})
   target_link_libraries(test_kms_gcp_online _mongocrypt::mongoc)
   target_link_libraries(test_kms_gcp_online kms_message_static)
   add_test (
      NAME test_kms_gcp_online
      COMMAND test_kms_gcp_online
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
   )
   set_tests_properties (
      test_kms_gcp_online test_kms_azure_online
      PROPERTIES
      SKIP_REGULAR_EXPRESSION "@@ctest-skip@@"
      # Older CMake (<3.16) does not support skipping via regex, so we'll use the
      # less-expressive skip-retcode.
      SKIP_RETURN_CODE 2
   )
endif ()

=== debian/changelog ===
libmongocrypt (1.8.4-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:17:06 +0000

libmongocrypt (1.8.4-1build2) noble; urgency=medium

  * No-change rebuild against libbson-1.0-0t64

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 21 Mar 2024 18:22:00 +1300

libmongocrypt (1.8.4-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:25:07 +0000

libmongocrypt (1.8.4-1) unstable; urgency=medium

  * New upstream release.

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 03 Jan 2024 10:37:26 -0600

libmongocrypt (1.8.2-1) unstable; urgency=medium

  [ Roberto C. Sanchez ]
  * fix clean target (Closes: #1047944)
  * debian/rules: skip tests

  [ Kyle Kloberdanz ]
  * New upstream release.

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 06 Sep 2023 13:10:31 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libmongocrypt
 Priority: optional
-Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
 Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
            Roberto C. Sanchez <roberto@connexer.com>,
            Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>

## libmongocrypt 1.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,12 @@
    ON
 )
 option (ENABLE_BUILD_FOR_PPA "Maintainer-only option for preparing PPA build" OFF)
-option (ENABLE_ONLINE_TESTS "Enable online tests and the csfle utility" ON)
+option (ENABLE_ONLINE_TESTS "Enable online tests and the csfle utility. Requires libmongoc." ON)
+# TODO MONGOCRYPT-661 When range V2 is default, remove this option.
+option (ENABLE_USE_RANGE_V2 "Enable the use_range_v2 flag by default for queryable encryption" OFF)
+if (ENABLE_USE_RANGE_V2)
+   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DQE_USE_RANGE_V2")
+endif ()
 
 if (ENABLE_WINDOWS_STATIC_RUNTIME)
    if (POLICY CMP0091)
@@ -69,6 +74,7 @@
       msvc:/W3 msvc:/WX msvc:/wd4996 msvc:/wd4359
       gnu-like:-Wall gnu-like:-Werror
       gnu-like:-Wswitch-enum gnu-like:-Wswitch-default
+      gnu-like:-Wsign-compare
       )
    add_link_options (
       # Enable link-time warnings. VS 2015 sees LNK4099 spuriously, but it is a
@@ -330,16 +336,3 @@
 target_compile_definitions (
    mongocrypt_static
    PUBLIC
-      MONGOCRYPT_STATIC_DEFINE
-      KMS_MSG_STATIC
-   )
-target_link_libraries (
-   mongocrypt_static
-   PRIVATE
-      _mongocrypt::libbson_for_static
-      kms_message_static
-      $<BUILD_INTERFACE:mongo::mlib>
-   PUBLIC
-      mongocrypt::platform
-      ${maybe_dfp_library}
-   )

=== debian/changelog ===
libmongocrypt (1.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Add Vcs-* links in debian/control (Closes: #1072880)
  * Update to Standards-Version 4.7.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 26 Jun 2024 20:50:45 -0400

libmongocrypt (1.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 01 May 2024 14:45:37 -0500

libmongocrypt (1.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Mon, 18 Mar 2024 10:14:55 -0500

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: libmongocrypt
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
+Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
 Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
            Roberto C. Sanchez <roberto@connexer.com>,
            Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>
 Build-Depends: debhelper (>= 10),
                cmake,
                libssl-dev,
-               pkg-config,
+               pkgconf,
                libintelrdfpmath-dev (>= 2.0u2-6) [!mips64el !mipsel],
                libbson-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/mongodb/libmongocrypt
+Vcs-Git: https://github.com/mongodb/libmongocrypt.git
+Vcs-Browser: https://github.com/mongodb/libmongocrypt/tree/debian/unstable
 
 Package: libmongocrypt-dev
 Section: libdevel

## libmongocrypt 1.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,10 @@
    cmake_policy (SET CMP0091 NEW)
 elseif (DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
    message (WARNING "The CMAKE_MSVC_RUNTIME_LIBRARY variable is set, but CMake is too old to understand it")
+endif ()
+
+if (POLICY CMP0135)
+   cmake_policy (SET CMP0135 NEW)
 endif ()
 
 project (mongocrypt C)
@@ -21,11 +25,6 @@
 )
 option (ENABLE_BUILD_FOR_PPA "Maintainer-only option for preparing PPA build" OFF)
 option (ENABLE_ONLINE_TESTS "Enable online tests and the csfle utility. Requires libmongoc." ON)
-# TODO MONGOCRYPT-661 When range V2 is default, remove this option.
-option (ENABLE_USE_RANGE_V2 "Enable the use_range_v2 flag by default for queryable encryption" OFF)
-if (ENABLE_USE_RANGE_V2)
-   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DQE_USE_RANGE_V2")
-endif ()
 
 if (ENABLE_WINDOWS_STATIC_RUNTIME)
    if (POLICY CMP0091)
@@ -336,3 +335,12 @@
 target_compile_definitions (
    mongocrypt_static
    PUBLIC
+      MONGOCRYPT_STATIC_DEFINE
+      KMS_MSG_STATIC
+   )
+target_link_libraries (
+   mongocrypt_static
+   PRIVATE
+      _mongocrypt::libbson_for_static
+      kms_message_static
+      $<BUILD_INTERFACE:mongo::mlib>

=== bindings/cs/CMakeLists.txt ===

configure_file(cs.sln cs.sln COPYONLY)
configure_file(MongoDB.Driver.snk MongoDB.Driver.snk COPYONLY)

configure_file(MongoDB.Libmongocrypt/MongoDB.Libmongocrypt.csproj MongoDB.Libmongocrypt/MongoDB.Libmongocrypt.csproj COPYONLY)
configure_file(MongoDB.Libmongocrypt/Package.include.template.csproj MongoDB.Libmongocrypt/Package.csproj.include)

configure_file(MongoDB.Libmongocrypt.Test/MongoDB.Libmongocrypt.Test.csproj MongoDB.Libmongocrypt.Test/MongoDB.Libmongocrypt.Test.csproj COPYONLY)
configure_file(MongoDB.Libmongocrypt.Test/Package.include.template.csproj MongoDB.Libmongocrypt.Test/Package.csproj.include)

configure_file(MongoDB.Libmongocrypt.Test/MongoDB.Libmongocrypt.Test.csproj MongoDB.Libmongocrypt.Test32/MongoDB.Libmongocrypt.Test32.csproj COPYONLY)
configure_file(MongoDB.Libmongocrypt.Test/Package.include.template.csproj MongoDB.Libmongocrypt.Test32/Package.csproj.include)

configure_file(MongoDB.Libmongocrypt.Example/MongoDB.Libmongocrypt.Example.csproj MongoDB.Libmongocrypt.Example/MongoDB.Libmongocrypt.Example.csproj COPYONLY)
configure_file(MongoDB.Libmongocrypt.Example/Package.include.template.csproj MongoDB.Libmongocrypt.Example/Package.csproj.include)

=== debian/changelog ===
libmongocrypt (1.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove Kyle from uploaders.

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 02 Aug 2024 17:54:28 -0400

## libmongocrypt 1.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -82,8 +82,6 @@
       "$<IF:$<C_COMPILER_ID:MSVC>,/WX;/ignore:4217;/ignore:4049;/ignore:4099,-Werror>"
       )
 endif ()
-
-add_subdirectory (bindings/cs)
 
 include (GenerateExportHeader)
 
@@ -116,6 +114,7 @@
    src/mc-fle2-payload-uev-common.c
    src/mc-fle2-payload-uev-v2.c
    src/mc-fle2-rfds.c
+   src/mc-fle2-tag-and-encrypted-metadata-block.c
    src/mc-range-edge-generation.c
    src/mc-range-mincover.c
    src/mc-range-encoding.c
@@ -343,4 +342,3 @@
    PRIVATE
       _mongocrypt::libbson_for_static
       kms_message_static
-      $<BUILD_INTERFACE:mongo::mlib>

=== debian/changelog ===
libmongocrypt (1.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 12 Nov 2024 11:40:46 -0500

## libmongocrypt 1.13.0

=== debian/changelog ===
libmongocrypt (1.13.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 26 Mar 2025 11:19:49 -0400

## libmongocrypt 1.13.1

=== debian/changelog ===
libmongocrypt (1.13.1-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 05 Apr 2025 10:57:55 -0400

## libmongocrypt 1.13.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -120,6 +120,9 @@
    src/mc-range-encoding.c
    src/mc-rangeopts.c
    src/mc-reader.c
+   src/mc-schema-broker.c
+   src/mc-str-encode-string-sets.c
+   src/mc-text-search-str-encode.c
    src/mc-tokens.c
    src/mc-writer.c
    src/mongocrypt-binary.c
@@ -151,6 +154,9 @@
    src/os_posix/os_mutex.c
    src/os_win/os_dll.c
    src/os_posix/os_dll.c
+   src/unicode/case-fold-map.c
+   src/unicode/diacritic-fold-map.c
+   src/unicode/fold.c
    )
 
 # If MONGOCRYPT_CRYPTO is not set, choose a system default.
@@ -334,11 +340,3 @@
 target_compile_definitions (
    mongocrypt_static
    PUBLIC
-      MONGOCRYPT_STATIC_DEFINE
-      KMS_MSG_STATIC
-   )
-target_link_libraries (
-   mongocrypt_static
-   PRIVATE
-      _mongocrypt::libbson_for_static
-      kms_message_static

=== kms-message/CMakeLists.txt ===
--- 
+++ 
@@ -71,6 +71,14 @@
          "KMS_MESSAGE_ENABLE_CRYPTO_LIBCRYPTO")
 endif()
 
+include (CheckSymbolExists)
+CHECK_SYMBOL_EXISTS (gmtime_r time.h KMS_MESSAGE_HAVE_GMTIME_R)
+if (KMS_MESSAGE_HAVE_GMTIME_R)
+   set (KMS_MESSAGE_DEFINITIONS
+         ${KMS_MESSAGE_DEFINITIONS}
+         "KMS_MESSAGE_HAVE_GMTIME_R")
+endif ()
+
 include (TestBigEndian)
 TEST_BIG_ENDIAN (KMS_BIG_ENDIAN)
 if (KMS_BIG_ENDIAN)
@@ -114,9 +122,9 @@
    else()
       include (FindOpenSSL)
       target_link_libraries(kms_message "${OPENSSL_LIBRARIES}")
-      target_include_directories(kms_message PRIVATE "${OPENSSL_INCLUDE_DIR}")
+      target_include_directories(kms_message SYSTEM PRIVATE "${OPENSSL_INCLUDE_DIR}")
       target_link_libraries(kms_message_static "${OPENSSL_LIBRARIES}")
-      target_include_directories(kms_message_static PRIVATE "${OPENSSL_INCLUDE_DIR}")
+      target_include_directories(kms_message_static SYSTEM PRIVATE "${OPENSSL_INCLUDE_DIR}")
    endif()
 endif ()
 
@@ -259,7 +267,7 @@
    else()
       include (FindOpenSSL)
       target_link_libraries(test_kms_request "${OPENSSL_LIBRARIES}")
-      target_include_directories(test_kms_request PRIVATE "${OPENSSL_INCLUDE_DIR}")
+      target_include_directories(test_kms_request SYSTEM PRIVATE "${OPENSSL_INCLUDE_DIR}")
    endif()
 
    add_test (

=== bindings/python/requirements.txt ===
cffi>=1.12.0,<2
cryptography>=40
packaging>=21.0
httpx>=0.25.0

=== .evergreen/linker_tests_deps/app/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5)
project (app C)
add_executable (app app.c)
find_package (bson-1.0 1.11 REQUIRED)
message ("--   libbson found version \"${bson-1.0_VERSION}\"")
target_link_libraries (app PRIVATE mongo::bson_static)

find_package (mongocrypt REQUIRED)
target_link_libraries (app PRIVATE mongo::mongocrypt)

=== debian/changelog ===
libmongocrypt (1.13.2-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 11 Apr 2025 00:41:45 -0400

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Priority: optional
 Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
 Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
-           Roberto C. Sanchez <roberto@connexer.com>,
-           Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>
+           Roberto C. Sanchez <roberto@connexer.com>
 Build-Depends: debhelper (>= 10),
                cmake,
                libssl-dev,

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -B$(CURDIR)/cmake-build -- \
+	dh_auto_configure -- \
 	-DBUILD_VERSION=$(DEB_VERSION_UPSTREAM) \
 	-DUSE_SHARED_LIBBSON=ON \
 	-DMONGOCRYPT_MONGOC_DIR=USE-SYSTEM \
@@ -36,11 +36,8 @@
 	$(DFP_CONFIG_OPTION) \
 	-DCMAKE_BUILD_TYPE=RelWithDebInfo
 
-override_dh_auto_build:
-	dh_auto_build -B$(CURDIR)/cmake-build -- all
-
-override_dh_auto_install:
-	dh_auto_install -B$(CURDIR)/cmake-build
+override_dh_auto_test:
+	echo "Skip dh_auto_test because upstream CI already tests extensively"
 
 override_dh_missing:
 	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libmongocrypt-$1.tar.gz%" \
https://github.com/mongodb/libmongocrypt/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
